package com.lightsky.monitor

import android.content.Context
import android.graphics.Canvas
import android.util.AttributeSet
import android.view.Choreographer
import android.view.View
import com.lightsky.utils.LogUtils


/**
 * Created by xupengpai on 2021/1/6.
 */
class FirstFrameView : View {

    constructor(context: Context?) : super(context)
    constructor(context: Context?, attrs: AttributeSet?) : super(context, attrs)
    constructor(context: Context?, attrs: AttributeSet?, defStyleAttr: Int) : super(context, attrs, defStyleAttr)
    constructor(context: Context?, attrs: AttributeSet?, defStyleAttr: Int, defStyleRes: Int) : super(context, attrs, defStyleAttr, defStyleRes)

    var frameCallback: Choreographer.FrameCallback? = null
    var called: Boolean = false

    override fun onDraw(canvas: Canvas) {
        super.onDraw(canvas)
        if(!called) {
            frameCallback?.let { callback ->
                called = true
                //监听vsync， 执行该回调时认为View已经渲染完成
                Choreographer.getInstance().postFrameCallback { frameTimeNanos ->
                    Choreographer.getInstance().removeFrameCallback(callback)
                    callback.doFrame(frameTimeNanos)
                }
//            post {
//                LogUtils.e("AppMonitor", "---------- FirstFrameView")
//            }
            }
        }
    }

}

